unit uGuiThreads;

interface

uses
  System.Classes, FMX.Types, System.Math, System.SysUtils;

type
  TThreadAddAndScrollGraph = class(TThread)
  protected
    aValue: integer;
    constructor Create(CreateSuspended: Boolean);
    procedure Execute; override;
  end;

  procedure StartAddAndScroll;
  procedure StopAddAndScroll;

var
  AddAndScrollSleepTime: integer;
  IsAddingAndScrolling: boolean;

implementation

uses
  FormMain;

procedure StartAddAndScroll;
begin
  if IsAddingAndScrolling then Exit;
  IsAddingAndScrolling := true;
  with TThreadAddAndScrollGraph.Create(False) do
    FreeOnTerminate := True;
end;

procedure StopAddAndScroll;
begin
  IsAddingAndScrolling := false;
end;

{ TThreadAddAndScrollGraph }
constructor TThreadAddAndScrollGraph.Create(CreateSuspended: Boolean);
begin
  inherited;
  aValue := 0;
end;

procedure TThreadAddAndScrollGraph.Execute;
begin
  inherited;
  while not Terminated do begin
    TThread.Synchronize(nil,
      procedure
      begin
        aValue := aValue + RandomRange(-10, 10);
        aValue := Max(0, aValue); //Prevent values less than 0
        aValue := Min(100, aValue); //Prevent values greater than 100;
        frmMain.AddAndScrollChart(Now, aValue);
      end);

    Sleep(AddAndScrollSleepTime);
    if not IsAddingAndScrolling then Exit;
  end;
end;


initialization
  AddAndScrollSleepTime := 40; //40ms
  IsAddingAndScrolling := false;
end.
